Don't check for the existence of sourcedir in the restore script. It may not
[backups/.git] / scripts / restore-script.sh
index 1bf8dccfd4e8326670ef9ef189598d24c6cecc33..0796bef2d9155e5d1e99e1a52f66f4bd97710af0 100755 (executable)
@@ -1,34 +1,61 @@
 #!/bin/sh
 
-export PATH=$rundir:/bin:/usr/bin
-
-if [ $# != 1 ]; then
-  echo >&2 "Usage: $0 <source-directory> <target-directory>"
-  echo >&2 "Example: $0 / /"
+function err() {
+  echo >&2 "-E- $1"
   exit 1
+}
+
+[ -n "$3" ] && mountdir=$3
+
+[ -z "$mountdir" ] && err '$mountdir must be set'
+[ -z "$rundir"   ] && err '$rundir must be set'
+
+export PATH=${rundir%%/}:/bin:/usr/bin:/sbin:/usr/sbin:/sw/bin
+
+if [ ! -z "$1" -o ! -d "$2" ]; then
+  err "
+Usage: $0 <source-dir> <relocate-dir> [<mnt-dir>]
+       source-dir   - directory on backup disks to restore from (relative to $mountdir)
+       relocate-dir - base directory to restore files to        (usually /)
+       mnt-dir      - directory where backup disk is mounted    (optional)
+
+  Examples:
+    % $0 / / /mnt/cdrom # Restore everything from disks (explicitly specifying dvd mount point.)
+    % $0 / /            # Restore everything from disks
+    % $0 /home /        # Restore only files under /home on disks to /home on the system
+    % $0 /home /home    # Restore files under /home on disks to /home/home on the system (probably not what you want.)
+"
 fi
 
-device=$(mount | grep "on $mountdir " | awk '{print$1}')
+device=$(mount | grep "on ${mountdir%%/} " | awk '{print$1}')
+
+[ -z "$device" ] && err "Cannot determine cdrom device"
 
-cp $mountdir/backups.db $mountdir/backup-status.txt $rundir
-dbfile=$rundir/backups.db
+cp ${mountdir%%/}/backups.db ${mountdir%%/}/backup-status.txt $rundir
+dbfile=${rundir%%/}/backups.db
 
-for date in $(cat $dbfile | list-dates.sh); do
+dates=$(cat $dbfile | list-dates.sh)
+
+for date in $dates; do
   success=false
   while ! $success; do
     eject $device
-    echo >&2 "Please insert backup disk:  $date"
+    [ $? != 0 ] && err "Cannot eject the disk. Drive is busy. Run lsof $mountdir to see why."
+    echo "Please insert backup disk:  $date"
+    echo "Press Enter to continue"
     read bogus
+    eject -t $device
 
     # Mount the media
-    mount -t ext2 $device $mountdir
-    if [ "" != "$(grep -l $date $mountdir/backup-status.txt)" ]; then
+    mount -t ext2 $device ${mountdir%%/}
+
+    if grep -q $date ${mountdir%%/}/backup-status.txt; then
       success=true
     else
-      echo >&2 "This doesn't seem to be the right disk."
+      echo "This doesn't seem to be the right disk."
     fi
   done
 
-  rsyncopts="-l -p -t -g -o -0 --files-from=- --stats --progress "
-  cat $dbfile | files-from-date.sh | rsync $rsyncopts $1 $2
+  rsyncopts="-W -H -S -l -p -t -g -o -0 --files-from=- --stats --progress"
+  cat $dbfile | files-from-date.sh $date | grep -z -Z -e "^${1%/}/" | rsync $rsyncopts ${mountdir%%/}/ ${2%%/}/
 done